---
title: Axis options
comments: |
  This file is used in the following visualizations: time series.
---

Options under the **Axis** section control how the x- and y-axes are rendered. Some options don't take effect until you click outside of the field option box you're editing. You can also press `Enter`.

| Option                             | Description                                                                                                        |
| ---------------------------------- | ------------------------------------------------------------------------------------------------------------------ |
| Time zone                          | Set the desired time zones to display along the x-axis.                                                            |
| [Placement](#placement)            | Select the placement of the y-axis.                                                                                |
| Label                              | Set a y-axis text label. If you have more than one y-axis, then you can assign different labels using an override. |
| Width                              | Set a fixed width for the axis. By default, Grafana dynamically calculates the width of an axis.                   |
| Show grid lines                    | Set the axis grid line visibility.<br>                                                                             |
| Color                              | Set the color of the axis.                                                                                         |
| Show border                        | Set the axis border visibility.                                                                                    |
| Scale                              | Set the y-axis values scale.<br>                                                                                   |
| Centered zero                      | Set the y-axis so it's centered on zero.                                                                           |
| [Soft min](#soft-min-and-soft-max) | Set a soft min to better control the y-axis limits. zero.                                                          |
| [Soft max](#soft-min-and-soft-max) | Set a soft max to better control the y-axis limits. zero.                                                          |
